USE [Demokratia]
GO

DECLARE @Numeros TABLE  (Id INT, Numero NVARCHAR(2))
DECLARE @cnt INT = 1;
WHILE @cnt <= 99
BEGIN
	INSERT INTO @Numeros (Id, Numero)
	VALUES (@cnt, REPLICATE('0',2-LEN(CONVERT(NVARCHAR(2),@cnt))) + CONVERT(NVARCHAR(2), @cnt))
					
	SET @cnt = @cnt + 1;
END;

DECLARE @Rsp NVARCHAR(200)

BEGIN -- DemarcacionElectoral

-- Estado

EXEC dbo.usp_DemarcacionElectoral_Insertar
	'josue.marti',
	NULL,
	'NombreEstado',
	'Estado',
	@Rsp OUTPUT

SELECT @Rsp

-- ComunidadesAutonomas
INSERT INTO dbo.DemarcacionElectoral (IdPadre, Nombre, Tipo)
SELECT E.Id, 'Comunidad Autonoma ' + N.Numero, 'ComunidadAutonoma'
FROM @Numeros N
	CROSS JOIN dbo.DemarcacionElectoral E  
WHERE N.Id <=2 AND E.Tipo='Estado'

-- Provincias
INSERT INTO dbo.DemarcacionElectoral (IdPadre, Nombre, Tipo)
SELECT CA.Id, 'Provincia ' + CONVERT(NVARCHAR(50), CA.Id) + '-' + N.Numero, 'Provincia'
FROM @Numeros N
	CROSS JOIN dbo.DemarcacionElectoral CA  
WHERE N.Id <=5 AND CA.Tipo='ComunidadAutonoma'

-- Municipios
INSERT INTO dbo.DemarcacionElectoral (IdPadre, Nombre, Tipo)
SELECT PR.Id, 'Municipio ' + CONVERT(NVARCHAR(50), PR.Id) + '-' + N.Numero, 'Municipio'
FROM @Numeros N
	CROSS JOIN dbo.DemarcacionElectoral PR  
WHERE N.Id <=10 AND PR.Tipo='Provincia'

-- Distritos
INSERT INTO dbo.DemarcacionElectoral (IdPadre, Nombre, Tipo)
SELECT MU.Id, 'Distrito ' + CONVERT(NVARCHAR(50), MU.Id) + '-' + N.Numero, 'Distrito'
FROM @Numeros N
	CROSS JOIN dbo.DemarcacionElectoral MU  
WHERE N.Id <=1 AND MU.Tipo='Municipio'

-- Secciones
INSERT INTO dbo.DemarcacionElectoral (IdPadre, Nombre, Tipo)
SELECT DI.Id, 'Seccion ' + CONVERT(NVARCHAR(50), DI.Id) + '-' + N.Numero, 'Seccion'
FROM @Numeros N
	CROSS JOIN dbo.DemarcacionElectoral DI
WHERE N.Id <=3 AND DI.Tipo='Distrito'

END

BEGIN -- MetodoCalculoResultados

EXEC dbo.usp_MetodoCalculoResultados_Insertar
	'josue.marti',
	'Sistema D''Hondt',
	@Rsp OUTPUT

SELECT @Rsp

END

BEGIN -- ProcesosElectoral

DECLARE @IdMetodo INT
DECLARE @FechaElecciones DATETIME
DECLARE @FechaHoraInicio DATETIME
DECLARE @FechaHoraFin DATETIME
SET @IdMetodo =  IDENT_CURRENT('MetodoCalculoResultados')
SET @FechaElecciones = CONVERT(DATETIME, '20-02-2021',103)
SET @FechaHoraInicio = CONVERT(DATETIME, '20-02-2021 9:00',103)
SET @FechaHoraFin = CONVERT(DATETIME, '20-02-2021 21:00',103)

EXEC dbo.usp_ProcesoElectoral_Insertar
	'josue.marti',
	'Proceso Electoral 1',
	@FechaElecciones,
	@FechaHoraInicio,
	@FechaHoraFin,
	'Estado',
	@IdMetodo,
	@Rsp OUTPUT

SELECT @Rsp

SET @FechaElecciones = CONVERT(DATETIME, '07-04-2021',103)
SET @FechaHoraInicio = CONVERT(DATETIME, '07-04-2021 9:00',103)
SET @FechaHoraFin = CONVERT(DATETIME, '07-04-2021 21:00',103)

EXEC dbo.usp_ProcesoElectoral_Insertar
	'josue.marti',
	'Proceso Electoral 2',
	@FechaElecciones,
	@FechaHoraInicio,
	@FechaHoraFin,
	'Estado',
	@IdMetodo,
	@Rsp OUTPUT

SELECT @Rsp

SET @FechaElecciones = CONVERT(DATETIME, '07-05-2022',103)
SET @FechaHoraInicio = CONVERT(DATETIME, '07-05-2022 9:00',103)
SET @FechaHoraFin = CONVERT(DATETIME, '07-05-2022 21:00',103)

EXEC dbo.usp_ProcesoElectoral_Insertar
	'josue.marti',
	'Proceso Electoral 3',
	@FechaElecciones,
	@FechaHoraInicio,
	@FechaHoraFin,
	'Estado',
	@IdMetodo,
	@Rsp OUTPUT

SELECT @Rsp

END

BEGIN -- ReglaCensoElectoral

EXEC dbo.usp_ReglaCensoElectoral_Insertar
	'josue.marti',
	'Mayores de 16 aos',
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaCensoElectoral_Insertar
	'josue.marti',
	'Mayores de 18 aos',
	@Rsp OUTPUT

SELECT @Rsp

END

BEGIN -- ReglaCensoPorProceso

DECLARE @IdReglaCensoElectoral INT
SET @IdReglaCensoElectoral =  IDENT_CURRENT('ReglaCensoElectoral')
EXEC dbo.usp_ReglaCensoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 1',
	@IdReglaCensoElectoral,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaCensoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 2',
	@IdReglaCensoElectoral,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaCensoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 3',
	@IdReglaCensoElectoral,
	@Rsp OUTPUT

SELECT @Rsp


END

BEGIN -- ReglaMesaElectoral y ReglaMesaPorProceso

DECLARE @IdReglaMesa INT

EXEC dbo.usp_ReglaMesaElectoral_Insertar
	'josue.marti',
	'Mayores de 18 aos',
	@Rsp OUTPUT

SELECT @Rsp

SET @IdReglaMesa =  IDENT_CURRENT('ReglaMesaElectoral')
EXEC dbo.usp_ReglaMesaPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 1',
	@IdReglaMesa,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaMesaPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 2',
	@IdReglaMesa,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaMesaPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 3',
	@IdReglaMesa,
	@Rsp OUTPUT

SELECT @Rsp


EXEC dbo.usp_ReglaMesaElectoral_Insertar
	'josue.marti',
	'Menores de 70 aos',
	@Rsp OUTPUT

SELECT @Rsp

SET @IdReglaMesa =  IDENT_CURRENT('ReglaMesaElectoral')
EXEC dbo.usp_ReglaMesaPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 1',
	@IdReglaMesa,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaMesaPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 2',
	@IdReglaMesa,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaMesaPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 3',
	@IdReglaMesa,
	@Rsp OUTPUT

SELECT @Rsp


END

BEGIN -- ReglaPartidoPolitico y ReglaPartidoPorProceso

DECLARE @IdReglaPartido INT

EXEC dbo.usp_ReglaPartidoPolitico_Insertar
	'josue.marti',
	'Solicitud de inscripcin presentada',
	@Rsp OUTPUT

SELECT @Rsp

SET @IdReglaPartido =  IDENT_CURRENT('ReglaPartidoPolitico')
EXEC dbo.usp_ReglaPartidoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 1',
	@IdReglaPartido,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaPartidoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 2',
	@IdReglaPartido,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaPartidoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 3',
	@IdReglaPartido,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaPartidoPolitico_Insertar
	'josue.marti',
	'Formado por 3 o ms personas fsicas',
	@Rsp OUTPUT

SELECT @Rsp

SET @IdReglaPartido =  IDENT_CURRENT('ReglaPartidoPolitico')
EXEC dbo.usp_ReglaPartidoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 1',
	@IdReglaPartido,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaPartidoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 2',
	@IdReglaPartido,
	@Rsp OUTPUT

SELECT @Rsp

EXEC dbo.usp_ReglaPartidoPorProceso_Insertar
	'josue.marti',
	'Proceso Electoral 3',
	@IdReglaPartido,
	@Rsp OUTPUT

SELECT @Rsp


END

BEGIN --ComunicadoBOE

EXEC [dbo].[usp_ComunicadoBoe_Insertar]
	'josue.marti',
	'Proceso Electoral 1',
	'El proceso electoral 1 se celebrar el 20 de febrero de 2021',
	0,
	@Rsp OUTPUT

SELECT @Rsp

EXEC [dbo].[usp_ComunicadoBoe_Insertar]
	'josue.marti',
	'Proceso Electoral 2',
	'El proceso electoral 2 se celebrar el 7 de abril de 2021',
	0,
	@Rsp OUTPUT

SELECT @Rsp

EXEC [dbo].[usp_ComunicadoBoe_Insertar]
	'josue.marti',
	'Proceso Electoral 3',
	'El proceso electoral 3 se celebrar el 7 de mayo de 2022',
	0,
	@Rsp OUTPUT

SELECT @Rsp


END

BEGIN --VacantesPorDemarcacion

INSERT INTO VacantesPorDemarcacion (NombreProceso, IdDemarcacion, Numero)
SELECT P.Nombre, D.Id, (ABS(CHECKSUM(NewId())) % 18) + 3
FROM dbo.ProcesoElectoral P
	CROSS JOIN dbo.DemarcacionElectoral D
WHERE D.Tipo='Provincia'

END

BEGIN --Direccion

INSERT INTO dbo.Direccion (ReferenciaCatastral, TipoVia, Via, Resto, Municipio, Provincia)
SELECT REPLACE(CONVERT(NVARCHAR(50),NEWID()), '-', ''), 'Calle', 'Via ' + D.Nombre + ', ' + N.Numero, '', D.Nombre, P.Nombre 
FROM @Numeros N
	CROSS JOIN dbo.DemarcacionElectoral D
	INNER JOIN dbo.DemarcacionElectoral P ON D.IdPadre = P.Id
WHERE D.Tipo = 'Municipio'

END

BEGIN --Persona
DECLARE @FechaNacimiento DATETIME
SET @FechaNacimiento = CONVERT(DATETIME, '15-04-1969',103)

INSERT INTO dbo.Persona (NumeroDniONie, Nombre, Apellidos, Sexo, DomicilioHabitual, Nacionalidad, LugarNacimiento, FechaNacimiento, Estudios)
SELECT REPLACE(CONVERT(NVARCHAR(50),NEWID()), '-', ''), 'Nombre ' + LEFT(D.ReferenciaCatastral, 5), 
'Apellidos ' + RIGHT(D.ReferenciaCatastral, 5), 'Hombre', D.ReferenciaCatastral, 'ESPAOLA',
'Lugar Nacimiento', @FechaNacimiento, 'UNIVERSITARIOS'
FROM dbo.Direccion D

INSERT INTO dbo.Persona (NumeroDniONie, Nombre, Apellidos, Sexo, DomicilioHabitual, Nacionalidad, LugarNacimiento, FechaNacimiento, Estudios)
SELECT REPLACE(CONVERT(NVARCHAR(50),NEWID()), '-', ''), 'Mujer ' + LEFT(D.ReferenciaCatastral, 5), 
'Apellidos ' + RIGHT(D.ReferenciaCatastral, 5), 'Mujer', D.ReferenciaCatastral, 'ESPAOLA',
'Lugar Nacimiento', @FechaNacimiento, 'UNIVERSITARIOS'
FROM dbo.Direccion D

END

BEGIN -- Centro

INSERT INTO dbo.Direccion (ReferenciaCatastral, TipoVia, Via, Resto, Municipio, Provincia)
SELECT REPLACE(CONVERT(NVARCHAR(50),NEWID()), '-', ''), 'Avenida', 'Centro ' + D.Nombre, '', D.Nombre, P.Nombre 
FROM dbo.DemarcacionElectoral D
	INNER JOIN dbo.DemarcacionElectoral P ON D.IdPadre = P.Id
WHERE D.Tipo = 'Municipio'

INSERT INTO dbo.Centro (IdMunicipio, Nombre, Direccion)
SELECT D.Id, DI.Via, DI.ReferenciaCatastral
FROM dbo.Direccion DI
	INNER JOIN dbo.DemarcacionElectoral D ON DI.Municipio = D.Nombre
WHERE D.Tipo = 'Municipio' And DI.TipoVia = 'Avenida'

END

BEGIN --Mesa

INSERT INTO dbo.Mesa (IdMunicipio, NombreCentro, Nombre, IdSeccion)
SELECT C.IdMunicipio, C.Nombre, S.Nombre, S.Id
FROM dbo.DemarcacionElectoral S
	INNER JOIN dbo.DemarcacionElectoral D ON S.IdPadre = D.Id
	INNER JOIN dbo.Centro C ON C.IdMunicipio = D.IdPadre
WHERE S.Tipo = 'Seccion'

END

BEGIN --MesaPorProceso

INSERT INTO dbo.MesaPorProceso (NombreProceso, IdMunicipio, NombreCentro, NombreMesa)
SELECT P.Nombre, M.IdMunicipio, M.NombreCentro, M.Nombre
FROM dbo.Mesa M
	CROSS JOIN dbo.ProcesoElectoral P

END

BEGIN --CensoElectoral

DECLARE @SeccionSinCenso INT, @NombreMunicipio NVARCHAR(100)
SELECT @SeccionSinCenso = S.Id, @NombreMunicipio = M.Nombre
FROM dbo.DemarcacionElectoral S
	INNER JOIN dbo.DemarcacionElectoral D ON S.IdPadre = D.Id
	INNER JOIN dbo.DemarcacionElectoral M ON D.IdPadre = M.Id
WHERE S.Tipo='Seccion' AND NOT EXISTS
(
SELECT C.NumeroDniONie
FROM dbo.CensoElectoral C
WHERE S.Id = C.IdSeccion
)

WHILE @SeccionSinCenso IS NOT NULL
BEGIN
	
	INSERT INTO dbo.CensoElectoral (NumeroDniONie, CodigoPaisTelefono, NumeroTelefono, CorreoElectronico, IdSeccion)
	SELECT TOP 66 P.NumeroDniONie, '0034', CONVERT(NVARCHAR(50), ABS(CHECKSUM(NewId())) % 999999999),
	P.Nombre + '@gmail.com', @SeccionSinCenso
	FROM dbo.Persona P
		INNER JOIN dbo.Direccion D ON P.DomicilioHabitual = D.ReferenciaCatastral
	WHERE D.Municipio = @NombreMunicipio AND NOT EXISTS
	(
	SELECT C.NumeroDniONie
	FROM dbo.CensoElectoral C
	WHERE C.NumeroDniONie = P.NumeroDniONie
	)

	SET @SeccionSinCenso = NULL

	SELECT @SeccionSinCenso = S.Id, @NombreMunicipio = M.Nombre
	FROM dbo.DemarcacionElectoral S
		INNER JOIN dbo.DemarcacionElectoral D ON S.IdPadre = D.Id
		INNER JOIN dbo.DemarcacionElectoral M ON D.IdPadre = M.Id
	WHERE S.Tipo='Seccion' AND NOT EXISTS
	(
		SELECT C.NumeroDniONie
		FROM dbo.CensoElectoral C
		WHERE S.Id = C.IdSeccion
	)

END

END



BEGIN --CensoPorProceso

INSERT INTO dbo.CensoPorProceso (NombreProceso, NumeroDniONie, IdMunicipio, NombreCentro, NombreMesa)
SELECT P.Nombre, C.NumeroDniONie, M.IdMunicipio, M.NombreCentro, M.Nombre
FROM dbo.CensoElectoral C
	INNER JOIN dbo.Mesa M ON C.IdSeccion = M.IdSeccion 
	CROSS JOIN dbo.ProcesoElectoral P

END

BEGIN --Update Votado CensoPorProceso

-- 60%
update top (11880) dbo.CensoPorProceso set Votado = 1 WHERE NombreProceso='Proceso Electoral 1'

--65%
update top (12870) dbo.CensoPorProceso set Votado = 1 WHERE NombreProceso='Proceso Electoral 2'

END

BEGIN --IntegranteMesa

INSERT dbo.IntegranteMesa (NombreProceso, IdMunicipio, NombreCentro, NombreMesa, NumeroDniONie, CargoMesa)
SELECT M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa, MAX(C.NumeroDniONie), 'Presidente'
FROM dbo.MesaPorProceso M
	INNER JOIN dbo.CensoPorProceso C ON C.NombreProceso = M.NombreProceso AND C.IdMunicipio = M.IdMunicipio AND C.NombreCentro = M.NombreCentro AND C.NombreMesa = M.NombreMesa
WHERE NOT EXISTS
(
SELECT * FROM dbo.IntegranteMesa I
WHERE I.NombreProceso = M.NombreProceso AND I.IdMunicipio = M.IdMunicipio AND I.NombreCentro = M.NombreCentro AND I.NombreMesa = M.NombreMesa AND I.NumeroDniONie = C.NumeroDniONie
)
GROUP BY M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa

INSERT dbo.IntegranteMesa (NombreProceso, IdMunicipio, NombreCentro, NombreMesa, NumeroDniONie, CargoMesa)
SELECT M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa, MAX(C.NumeroDniONie), 'PrimerVocal'
FROM dbo.MesaPorProceso M
	INNER JOIN dbo.CensoPorProceso C ON C.NombreProceso = M.NombreProceso AND C.IdMunicipio = M.IdMunicipio AND C.NombreCentro = M.NombreCentro AND C.NombreMesa = M.NombreMesa
WHERE NOT EXISTS
(
SELECT * FROM dbo.IntegranteMesa I
WHERE I.NombreProceso = M.NombreProceso AND I.IdMunicipio = M.IdMunicipio AND I.NombreCentro = M.NombreCentro AND I.NombreMesa = M.NombreMesa AND I.NumeroDniONie = C.NumeroDniONie
)
GROUP BY M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa

INSERT dbo.IntegranteMesa (NombreProceso, IdMunicipio, NombreCentro, NombreMesa, NumeroDniONie, CargoMesa)
SELECT M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa, MAX(C.NumeroDniONie), 'SegundoVocal'
FROM dbo.MesaPorProceso M
	INNER JOIN dbo.CensoPorProceso C ON C.NombreProceso = M.NombreProceso AND C.IdMunicipio = M.IdMunicipio AND C.NombreCentro = M.NombreCentro AND C.NombreMesa = M.NombreMesa
WHERE NOT EXISTS
(
SELECT * FROM dbo.IntegranteMesa I
WHERE I.NombreProceso = M.NombreProceso AND I.IdMunicipio = M.IdMunicipio AND I.NombreCentro = M.NombreCentro AND I.NombreMesa = M.NombreMesa AND I.NumeroDniONie = C.NumeroDniONie
)
GROUP BY M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa

INSERT dbo.IntegranteMesa (NombreProceso, IdMunicipio, NombreCentro, NombreMesa, NumeroDniONie, CargoMesa)
SELECT M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa, MAX(C.NumeroDniONie), 'Suplente'
FROM dbo.MesaPorProceso M
	INNER JOIN dbo.CensoPorProceso C ON C.NombreProceso = M.NombreProceso AND C.IdMunicipio = M.IdMunicipio AND C.NombreCentro = M.NombreCentro AND C.NombreMesa = M.NombreMesa
WHERE NOT EXISTS
(
SELECT * FROM dbo.IntegranteMesa I
WHERE I.NombreProceso = M.NombreProceso AND I.IdMunicipio = M.IdMunicipio AND I.NombreCentro = M.NombreCentro AND I.NombreMesa = M.NombreMesa AND I.NumeroDniONie = C.NumeroDniONie
)
GROUP BY M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa

INSERT dbo.IntegranteMesa (NombreProceso, IdMunicipio, NombreCentro, NombreMesa, NumeroDniONie, CargoMesa)
SELECT M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa, MAX(C.NumeroDniONie), 'Suplente'
FROM dbo.MesaPorProceso M
	INNER JOIN dbo.CensoPorProceso C ON C.NombreProceso = M.NombreProceso AND C.IdMunicipio = M.IdMunicipio AND C.NombreCentro = M.NombreCentro AND C.NombreMesa = M.NombreMesa
WHERE NOT EXISTS
(
SELECT * FROM dbo.IntegranteMesa I
WHERE I.NombreProceso = M.NombreProceso AND I.IdMunicipio = M.IdMunicipio AND I.NombreCentro = M.NombreCentro AND I.NombreMesa = M.NombreMesa AND I.NumeroDniONie = C.NumeroDniONie
)
GROUP BY M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa

INSERT dbo.IntegranteMesa (NombreProceso, IdMunicipio, NombreCentro, NombreMesa, NumeroDniONie, CargoMesa)
SELECT M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa, MAX(C.NumeroDniONie), 'Suplente'
FROM dbo.MesaPorProceso M
	INNER JOIN dbo.CensoPorProceso C ON C.NombreProceso = M.NombreProceso AND C.IdMunicipio = M.IdMunicipio AND C.NombreCentro = M.NombreCentro AND C.NombreMesa = M.NombreMesa
WHERE NOT EXISTS
(
SELECT * FROM dbo.IntegranteMesa I
WHERE I.NombreProceso = M.NombreProceso AND I.IdMunicipio = M.IdMunicipio AND I.NombreCentro = M.NombreCentro AND I.NombreMesa = M.NombreMesa AND I.NumeroDniONie = C.NumeroDniONie
)
GROUP BY M.NombreProceso, M.IdMunicipio, M.NombreCentro, M.NombreMesa

END

BEGIN --ComunicadoCiudadano

INSERT INTO dbo.ComunicadoCiudadano (NombreProceso, NumeroDniONie, NumeroComunicado, Fecha, Texto, Enviado)
SELECT I.NombreProceso, I.NumeroDniONie, 1, GETDATE(), 'Ha sido seleccionado para formar parte de su mesa como ' + I.CargoMesa, 0
FROM dbo.IntegranteMesa I

END

BEGIN --Alegacion

INSERT INTO dbo.Alegacion (NombreProceso, NumeroDniONie, NumeroAlegacion, Texto)
SELECT TOP 10 I.NombreProceso, I.NumeroDniONie, 1, 'Alegacion de ' + I.NumeroDniONie
FROM dbo.IntegranteMesa I
WHERE NombreProceso='Proceso Electoral 1'
ORDER BY NEWID()

INSERT INTO dbo.Alegacion (NombreProceso, NumeroDniONie, NumeroAlegacion, Texto)
SELECT TOP 10 I.NombreProceso, I.NumeroDniONie, 1, 'Alegacion de ' + I.NumeroDniONie
FROM dbo.IntegranteMesa I
WHERE NombreProceso='Proceso Electoral 2'
ORDER BY NEWID()

INSERT INTO dbo.Alegacion (NombreProceso, NumeroDniONie, NumeroAlegacion, Texto)
SELECT TOP 10 I.NombreProceso, I.NumeroDniONie, 1, 'Alegacion de ' + I.NumeroDniONie
FROM dbo.IntegranteMesa I
WHERE NombreProceso='Proceso Electoral 3'
ORDER BY NEWID()

END

BEGIN -- PartidoPolitico

INSERT INTO dbo.Direccion (ReferenciaCatastral, TipoVia, Via, Resto, Municipio, Provincia)
SELECT REPLACE(CONVERT(NVARCHAR(50),NEWID()), '-', ''), 'Rambla', 'Sede ' + D.Nombre, '', D.Nombre, D.Nombre 
FROM dbo.DemarcacionElectoral D
	INNER JOIN dbo.DemarcacionElectoral P ON D.IdPadre = P.Id
WHERE D.Tipo = 'Provincia'

INSERT INTO dbo.PartidoPolitico(Siglas, Nombre, SedeCentral)
SELECT CHAR((ABS(CHECKSUM(NewId())) % 25) + 65) + CHAR((ABS(CHECKSUM(NewId())) % 25) + 65) + CHAR((ABS(CHECKSUM(NewId())) % 25) + 65), 'Partido ' + DI.Via, DI.ReferenciaCatastral
FROM dbo.Direccion DI
WHERE DI.TipoVia = 'Rambla'

END

BEGIN -- ListaCandidatos

INSERT INTO dbo.ListaCandidatos (NombreProceso, IdDemarcacion, SiglasPartidoPolitico, FechaConfirmacion, FechaPresentacion)
SELECT V.NombreProceso, V.IdDemarcacion, P.Siglas, GETDATE(), GETDATE() 
FROM dbo.VacantesPorDemarcacion V
	CROSS JOIN dbo.PartidoPolitico P

END

BEGIN -- Candidatura

	DECLARE 
    @siglas NVARCHAR(10),  
	@idDemarcacion INT,
    @proceso NVARCHAR(50),
	@escanyos INT;

	DECLARE cursor_listas CURSOR
	FOR SELECT L.SiglasPartidoPolitico, L.IdDemarcacion, L.NombreProceso, V.Numero
    FROM dbo.ListaCandidatos L
		INNER JOIN dbo.VacantesPorDemarcacion V ON L.NombreProceso = V.NombreProceso AND L.IdDemarcacion = V.IdDemarcacion

	OPEN cursor_listas;

	FETCH NEXT FROM cursor_listas INTO @siglas, @idDemarcacion, @proceso, @escanyos;

	WHILE @@FETCH_STATUS = 0
		BEGIN
			
			SELECT  @siglas, @idDemarcacion, @proceso, @escanyos

			INSERT INTO dbo.Candidatura (NombreProceso, IdDemarcacion, SiglasPartidoPolitico, NumeroDniONie, Orden, Reserva)		
			SELECT @proceso, @idDemarcacion, @siglas, NumeroDniONie, Orden, CASE WHEN Orden <= @escanyos THEN 0 ELSE 1 END
			FROM
			(
				SELECT TOP (@escanyos + 5) P.NumeroDniONie, ROW_NUMBER() OVER(ORDER BY P.NumeroDniONie ASC) As Orden
				FROM dbo.Persona P
				WHERE NOT EXISTS 
				(
					SELECT NumeroDniONie
					FROM dbo.Candidatura C
					WHERE C.NombreProceso = @proceso AND C.NumeroDniONie = P.NumeroDniONie
				)
			) T

			FETCH NEXT FROM cursor_listas INTO @siglas, @idDemarcacion, @proceso, @escanyos;
		END;

	CLOSE cursor_listas;

	DEALLOCATE cursor_listas;

END

BEGIN -- Votos

	DECLARE 
    @idMunicipio INT,
    @centro NVARCHAR(100),
	@mesa NVARCHAR(50),
	@votos INT;

	DECLARE cursor_mesa CURSOR
	FOR SELECT MP.NombreProceso, MP.IdMunicipio, MP.NombreCentro, MP.NombreMesa, V.IdDemarcacion, V.Numero, COUNT(CP.NumeroDniONie) Votos 
		FROM dbo.MesaPorProceso MP 
			INNER JOIN dbo.DemarcacionElectoral MU ON MP.IdMunicipio = MU.Id 
			INNER JOIN dbo.VacantesPorDemarcacion V ON V.NombreProceso = MP.NombreProceso AND V.IdDemarcacion = MU.IdPadre
			INNER JOIN dbo.CensoPorProceso CP ON CP.NombreProceso = MP.NombreProceso AND CP.IdMunicipio = MP.IdMunicipio AND CP.NombreCentro = MP.NombreCentro AND CP.NombreMesa = MP.NombreMesa AND CP.Votado = 1
		GROUP BY MP.NombreProceso, MP.IdMunicipio, MP.NombreCentro, MP.NombreMesa, V.IdDemarcacion, V.Numero

	OPEN cursor_mesa;

	FETCH NEXT FROM cursor_mesa INTO @proceso, @idMunicipio, @centro, @mesa, @idDemarcacion, @escanyos, @votos;

	WHILE @@FETCH_STATUS = 0
		BEGIN
			DECLARE @votosLista INT
			DECLARE @votosPresenciales INT
			DECLARE @votosTelematicos INT
			DECLARE @votosRestates INT

			SET @votosLista = @votos * 0.8
			SET @votosRestates = @votos - @votosLista
			SET @votosPresenciales = @votosLista * 0.7
			SET @votosTelematicos = @votosLista - @votosPresenciales

			INSERT INTO dbo.Votos (NombreProceso, IdDemarcacion, IdMunicipio, NombreCentro, NombreMesa, SiglasPartidoPolitico, Presenciales, Telematicos)
			SELECT TOP 1 @proceso, @idDemarcacion, @idMunicipio, @centro, @mesa, P.Siglas, @votosPresenciales, @votosTelematicos
			FROM dbo.PartidoPolitico P
			WHERE NOT EXISTS 
			(SELECT V.Presenciales FROM dbo.Votos V WHERE V.NombreProceso = @proceso 
			AND V.IdDemarcacion = @idDemarcacion AND V.IdMunicipio = @idMunicipio AND V.NombreCentro = @centro AND V.NombreMesa = @mesa AND
			V.SiglasPartidoPolitico = P.Siglas)
			ORDER BY NEWID()

			SET @votosLista = @votos * 0.15
			SET @votosRestates = @votosRestates - @votosLista
			SET @votosPresenciales = @votosLista * 0.7
			SET @votosTelematicos = @votosLista - @votosPresenciales

			INSERT INTO dbo.Votos (NombreProceso, IdDemarcacion, IdMunicipio, NombreCentro, NombreMesa, SiglasPartidoPolitico, Presenciales, Telematicos)
			SELECT TOP 1 @proceso, @idDemarcacion, @idMunicipio, @centro, @mesa, P.Siglas, @votosPresenciales, @votosTelematicos
			FROM dbo.PartidoPolitico P
			WHERE NOT EXISTS 
			(SELECT V.Presenciales FROM dbo.Votos V WHERE V.NombreProceso = @proceso 
			AND V.IdDemarcacion = @idDemarcacion AND V.IdMunicipio = @idMunicipio AND V.NombreCentro = @centro AND V.NombreMesa = @mesa AND
			V.SiglasPartidoPolitico = P.Siglas)
			ORDER BY NEWID()

			SET @votosLista = @votosRestates
			SET @votosPresenciales = @votosLista * 0.7
			SET @votosTelematicos = @votosLista - @votosPresenciales

			INSERT INTO dbo.Votos (NombreProceso, IdDemarcacion, IdMunicipio, NombreCentro, NombreMesa, SiglasPartidoPolitico, Presenciales, Telematicos)
			SELECT TOP 1 @proceso, @idDemarcacion, @idMunicipio, @centro, @mesa, P.Siglas, @votosPresenciales, @votosTelematicos
			FROM dbo.PartidoPolitico P
			WHERE NOT EXISTS 
			(SELECT V.Presenciales FROM dbo.Votos V WHERE V.NombreProceso = @proceso 
			AND V.IdDemarcacion = @idDemarcacion AND V.IdMunicipio = @idMunicipio AND V.NombreCentro = @centro AND V.NombreMesa = @mesa AND
			V.SiglasPartidoPolitico = P.Siglas)
			ORDER BY NEWID()
		
			FETCH NEXT FROM cursor_mesa INTO @proceso, @idMunicipio, @centro, @mesa, @idDemarcacion, @escanyos, @votos;
		END;

	CLOSE cursor_mesa;

	DEALLOCATE cursor_mesa;

END